
!StackInterpreter methodsFor: '*ObjectUsageTracerCogVMMaker' stamp: 'MarianoMartinezPeck 12/22/2011 10:58'!
internalByteSize: anOop
       "Answers the number of bytes the receiver occupies"
       | nbytes|
       self inline: true.
       nbytes := (self sizeBitsOf: anOop) + (self extraHeaderBytes: anOop).
       ^ nbytes.! !

!StackInterpreter methodsFor: '*ObjectUsageTracerCogVMMaker' stamp: 'MarianoMartinezPeck 12/22/2011 10:58'!
primitiveGetStatistics
	| oop usedCount unusedCount results usedMemory unusedMemory usedCountOop unusedCountOop usedMemoryOop unusedMemoryOop |
	
	usedCount := unusedCount := 0.
	usedMemory := unusedMemory := 0.
	
	self print: 'Start to check objects'; cr.
	oop := self firstAccessibleObject.
	[oop = nil] whileFalse: [
		(self isIntegerObject:  oop)
			ifFalse: [ 
				(objectMemory getExperimentalBitOf: oop)
					ifTrue: [
						usedCount := usedCount +1.
						usedMemory := usedMemory + (self internalByteSize: oop). ]
					ifFalse: [
						unusedCount := unusedCount +1.
						unusedMemory := unusedMemory + (self internalByteSize: oop). ].
			].
		oop := self accessibleObjectAfter: oop.
	].
	self print: 'Finish to check objects'; cr.
	
	self print: 'Push stadistics'; cr.
	self pushRemappableOop:
		(self instantiateClass: (self classArray) indexableSize: 4).
	self pushRemappableOop:
		(self positive64BitIntegerFor: usedCount).
	self pushRemappableOop:
		(self positive64BitIntegerFor: usedMemory).
	self pushRemappableOop:
		(self positive64BitIntegerFor: unusedCount).
	self pushRemappableOop:
		(self positive64BitIntegerFor: unusedMemory).
	
	self print: 'Pop stadistics'; cr.
	unusedMemoryOop := self popRemappableOop.
	unusedCountOop := self popRemappableOop.
	usedMemoryOop := self popRemappableOop.
	usedCountOop := self popRemappableOop.
	results := self popRemappableOop.	
		
	self print: 'Write stadistics in array'; cr.
	self storePointer: 0 ofObject: results withValue: usedCountOop.
	self storePointer: 1 ofObject: results withValue: unusedCountOop.
	self storePointer: 2 ofObject: results withValue: usedMemoryOop.
	self storePointer: 3 ofObject: results withValue: unusedMemoryOop.
	
	self print: 'Push result array in stadistics'; cr.
	self pop: 1 thenPush: results.
	
	! !

!StackInterpreter methodsFor: '*ObjectUsageTracerCogVMMaker' stamp: 'MarianoMartinezPeck 12/21/2011 15:21'!
primitiveSetHasToTrace
	| aBoolean |
	aBoolean := self booleanValueOf: self stackTop.
	self failed ifTrue:
		[^self primitiveFail.].
	hasToTrace := aBoolean.
	self pop: 1.

	
	! !

!StackInterpreter methodsFor: '*ObjectUsageTracerCogVMMaker' stamp: 'MarianoMartinezPeck 12/21/2011 15:14'!
traceObjectUsage: anOop
	((self isIntegerObject: anOop) not and: [hasToTrace])
		ifTrue: [ 
			objectMemory setExperimentalBitOf: anOop to: true.
			]
! !
